[layout]
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" encoding="utf-8" indent="yes" doctype-public="-//W3C//DTD XHTML 1.1//EN" doctype-system="http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd"/>
<xsl:template match="/">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="cz">
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8"/>
<meta name="description" content="description"/>
<meta name="keywords" content="keywords"/> 
<meta name="author" content="Arcsin, www.arcsin.se"/> 
<link rel="stylesheet" type="text/css" href="street_style/default.css"/>
<title>Sdružení TurnovFree.net</title>
</head>
<body>
<div><a style="float: left; clear:left; position: absolute; top: 5px; left: 5px; width: 32px; height: 32px; border: 1px dashed #000; background-color: #E5E5E5" href="{scriptname}?style=bright_pixel"><img src="img/bpsmall.png" style="border: 0px solid #fff;" alt="bright pixel style" width="32px" height="32px" /></a>
		<a style="float: left; clear:left; position: absolute; top: 5px; left: 44px; width: 32px; height: 32px; border: 1px dashed #fff; background-color: #000" href="{scriptname}?style=street_style"><img src="img/strsmall.png" style="border: 0px solid #fff;" alt="street style" width="32px" height="32px" /></a></div>
<div class="main">
	<div class="header_left">
		<div class="menu">
			{menu}
		</div>
		<a href="{scriptname}" id="big">Turnov</a>
	</div>
	<div class="header_right">
		<div class="gfx_margin"><span></span></div>
		<div class="gfx_header"><h1>Free.net</h1></div>
	</div>
	<div class="content">
		{content}
	</div>
</div>
<div class="footer">&#169; 2007 <a href="{scriptname}">TurnovFree.net</a>. Valid <a href="http://jigsaw.w3.org/css-validator/check/referer">CSS</a> &amp; <a href="http://validator.w3.org/check?uri=referer">XHTML</a>. Design by <a href="http://www.arcsin.se">Arcsin</a></div>
</body>
</html>
</xsl:template>
</xsl:stylesheet>
[/layout]
