<?php
	
# stybla - 21/03/2007
# zdenek.styblik@gmail.com
# distributed under GPLv2 or GPLv3 ? :)
#
# ToDo: @text independet on layout/design(XML integration) - DONE
# Note:
# BUGS: 
	class defaultLib {

		public $scriptname;
		public $xmlinput;
		public $template;
		public $ftpcs;
		public $configpath;
		private $rerun;
		private $rerun2;

		# inserts <root> tag into XML
		function __construct() {
			$this->configpath = '/home/apache/etc/';
			$this->xmlinput = "<root>\n";
			session_start();
			$this->rerun = 0;
			$this->rerun2 = 0;
			# bugger ?
			if (isset($_GET['style'])) {
				$_SESSION['style'] = $this->stripMe($_GET['style']);
				$_SESSION['style_valid'] = time() + 900;
			} 
		}

		public function start() {
			$this->scriptname = $this->getScriptname();
			if ($this->isStyleValid() == 0) {
				echo "error - style not valid;";
			} else {
				##### this is the future ... XML in DB? #######################
				#$connstring = "host={$config['db_host']} port={$config['db_port']} user={$config['db_user']} password={$config['db_password']} dbname={$config['db_dbname']}";
				#$dbconn = pg_connect($connstring) or die("Nelze se pripojit k DB - neco se posralo");
				###############################################################
				# if $_GET['content'] is empty
				if (!isset($_GET['content']) || empty($_GET['content']) || is_null($_GET['content']))  {
					$content = 'index';
				} else {
					$content = $this->stripMe($_GET['content']);
				}
				$style = $this->stripMe($_SESSION['style']);
				# useless after isStyleValid() function
				if (is_dir("../htmldir/{$style}")) {
					$temp['scriptname'] = $this->scriptname;
					$tags['menu'] = $this->getPartF("{$style}/menu.xsl", "menu");
					# this if should probably be replaced by function
					if (file_exists("{$style}/{$content}.xsl")) {
						# dummy
					} else {
						# and let us hope it does exist.
						# ToDo
						$content = "index";
					}
					$tags['content'] = $this->getPartF("{$style}/{$content}.xsl", $content);
					if (file_exists("xml/{$content}.xml")) {
									$this->xmlinput.= $this->getPartF("xml/{$content}.xml", "{$content}");
					}
					$this->template = $this->generateXSL("{$style}/layout.xsl", "layout", $tags);
					$this->template = $this->replacer($this->template, $temp);
					header("Content-type: text/html; charset=utf-8");
					echo $this->transform();
				} else {
					if ($this->rerun2 == 0) {
						# unset style and style_valid, set style from _default_
						# and try to start over
						$_SESSION['style'] = "";
						$_SESSION['style_valid'] = "";
						$this->chooseStyle();
						# loop protection
						$this->rerun2 = 1;
						self::start();
					} else {
						echo "stucked in loop;";
					}
				}
			}
		}

		### Xsl ###

		public function generateXML($input = false) {
						if ( $input !== false && $input ) {
										foreach ($input as $key=>$value) {
														if (is_array($value)) {
																		$this->xmlinput.= "<{$key}>\n";
																		self::generateXML($value);
																		$this->xmlinput.= "</{$key}>\n";
														} else {
																		$this->xmlinput.= "<{$key}>\n{$value}\n</{$key}>\n";
														}
										}	
						} else {
										# dummy
						}	
		}
		
		#public function loadDefaultXSL() {
		#				$this->template = file_get_contents("../html/{$style}/layout.xsl");
		#}
		
		public function generateXSL($tpl = false, $node = false, $tag = false) {
						$nodelen = strlen($node);
						$nodeStart = "[{$node}]";
						$nodeEnd = "[/{$node}]";
						$rawString = file_get_contents("{$tpl}");
						if ( strpos($rawString, $nodeStart) !== false ) {
										$tplPreF = substr($rawString, strpos($rawString, $nodeStart) + $nodelen + 3);
										$template = substr($tplPreF, 0, strpos($tplPreF, $nodeEnd));
						} else {
										$template = $rawString;
						}
						if ( is_array($tag) ) {
										foreach ($tag as $key=>$value) {
														$taglen = strlen($key);
														$fullTag = "{" . $key . "}";
														$replacement = $value;
														$template = substr_replace($template, $replacement, strpos($template, $fullTag, 1), $taglen + 2);
										}
						}
						return $template;
		}

		public function transform() {
				# enclose XML <root> tag
						$this->xmlinput.= "</root>\n";
				# load XSL file
						$xsl = new DomDocument();
						$xsl->loadXML($this->template);
				# load XML file
						$inputdom = new DomDocument();
						$inputdom->loadXML($this->xmlinput);
				#	load XsltProcessor and fed it with XSL file
						$proc = new XsltProcessor();
						$xsl = $proc->importStylesheet($xsl);
				# transform XML + XSL --> XHTML and do output
						$newdom = $proc->transformToDoc($inputdom);
						return $newdom->saveXML();
		}

		public function replacer($input, $tag) {
						$replaced = $input;
						if ( is_array($tag) ) {
										foreach ($tag  as $key=>$value) {
														$taglen = strlen($key);
														$fullTag = "{" . $key . "}";
														$replacement = $value;
														#$replaced = substr_replace($replaced, $replacement, strpos($replaced, $fullTag, 1), $taglen + 2);
														$replaced = ereg_replace($fullTag, $value, $replaced);
														#$pos = strpos($replaced, $fullTag);
														#if ( !is_bool($pos) ) {
																		#$array[$key] = $value;
																		#$this->replacer($replaced, $array);
														#}
										}
						}
						return $replaced;
		}

		public function getPartF($tpl = false, $node = false, $tag = false) {
						$nodelen = strlen($node);
						$nodeStart = "[{$node}]";
						$nodeEnd = "[/{$node}]";
						$rawString = file_get_contents("{$tpl}");
						if ( strpos($rawString, $nodeStart) !== false ) {
							$tplPreF = substr($rawString, strpos($rawString, $nodeStart) + $nodelen + 3);
							$ttpl = substr($tplPreF, 0, strpos($tplPreF, $nodeEnd));
						} else {
							$ttpl = $rawString;
						}
						if ( is_array($tag) ) {
							foreach ($tag as $key=>$value) {
								$taglen = strlen($key);
								$fullTag = "{" . $key . "}";
								$replacement = $value;
								#$ttpl = substr_replace($ttpl, $replacement, strpos($ttpl, $fullTag, 1), $taglen + 2);
								$ttpl = str_replace($fullTag, $replacement, $ttpl); 
							}	
						}
						return $ttpl;
						
		}
		
		### EOXsl ###

		### Common ###
		#
		# choose random style with a little modified _fair_ randomization
		private function chooseStyle() {
			$random = mt_rand();
			if (($random % 2) == 0) {
				if (isset($_SESSION['style']) && $_SESSION['style'] == "bright_pixel") {
					$style = "street_style";
				} else {
					$style = "bright_pixel";
				}
			} else {
				if (isset($_SESSION['style']) && $_SESSION['style'] == "street_style") {
					$style = "bright_pixel";
				} else {
					$style = "street_style";
				}
			}
			$_SESSION['style'] = $style;
			# change style every 5 minutes
			$_SESSION['style_valid'] = time() + 300;
		}

		# _is style valid?_ thing
		private function isStyleValid() {
			$this->rerun = 0;
			$returnval = 0;
			do {
				if (!isset($_SESSION['style']) || empty($_SESSION['style']) || !isset($_SESSION['style_valid']) || !is_numeric($_SESSION['style_valid'])) {
					$this->chooseStyle();
					$returnval = 1;
				} else {
					$style = $this->stripMe($_SESSION['style']);
					if (is_dir("../htmldir/{$style}") && is_readable("../htmldir/{$style}")) {
						# style is half-way ok
						$returnval = 1;
						if (isset($_SESSION['style_valid'])) {
							$valid_until = $this->stripMe($_SESSION['style_valid']);
						} else {
							$valid_until = 0;
						}
						$now = time();
						if ($now > $valid_until) {
							$this->chooseStyle();
							$returnval = 1;
						} else {
							# do nothing
							$returnval = 1;
						}
					} else {
						if ($this->rerun == 0) {
							$this->chooseStyle();
							$this->rerun = 1;
							$returnval = 0;
						} else {
							$returnval = 0;
							break;
						}
					}
				}
			} while($returnval <= 0);
			return $returnval;
		}

		public function stripMe($string, $forcequote = 0) {
		  if(!isset($string)) {
	  	  $string="";
			}
			$string=trim($string);
			if($forcequote==1) {
	  	  $string=addslashes($string);
			} elseif(!get_magic_quotes_gpc()&&$forcequote==0) {
	  		$string=addslashes($string);
			}
			$string=ereg_replace("\n","<br />", $string);
	   	return $string;
		}

		public function stripText($string, $forcequote = 0) {
			if(!isset($string)) {
	  		$string = "";
			}
			$string=trim($string);
			if($forcequote == 1) {
	  	  $string = addslashes($string);
			} elseif(!get_magic_quotes_gpc() && $forcequote == 0) {
	  		$string = addslashes($string);
			}
	   	return $string;	
		}

		public function emailCheck($email) {
			$checkpoint = ereg("^[A-z0-9_\.]+@[A-z0-9\.-]+\.[A-z]{2,3}$", $email);
			return $checkpoint;
		}

		public function redirect($text = null, $url = null) {
			if (!is_null($text) && !is_null($url)) {
				$tag['text'] = $this->stripMe($text);
				$tag['redirect'] = preg_replace("/&+/", "&#38;", $url);
				$html = $this->getPartF('template/default.xsl', 'redirect', $tag);
				return $html;
			}
		}

		### EOCommon ###
		
		### Other ###

		# return the name of this script
		public function getScriptname() {
			$returnMe = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
			return $returnMe;
		}
		
		# some general functions #

		# end of general fcs #
		
		### EOOther ###
	}
	
?>
